'use strict';

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * 不背单词公用类
 */
var General = function () {
  function General() {
    _classCallCheck(this, General);
  }

  /**
   * 选择单词查询单词
   */
  General.prototype.onSelectWord = function onSelectWord() {
    var that = this;
    this.lastValue; //最后选中单词
    this.selRange; //最后选中对象
    this.isResume = false; //继续查词
    // 是否为英文字母
    var isAlpha = function isAlpha(str) {
      return (/[a-zA-Z']+/.test(str)
      );
    };
    document.addEventListener('touchend', function (event) {
      // 去掉android选择菜单
      event.preventDefault();
    });
    // 点击选中,解决iOS12以及以下点击不能选中问题
    var hammer = new Hammer(document, {});
    hammer.on('tap', function (event) {
      var clientX = event.clientX || event.center.x;
      var clientY = event.clientY || event.center.y;
      var oRange = document.caretRangeFromPoint(clientX, clientY);
      var so = oRange.startOffset;
      var eo = oRange.endOffset;
      var tr = oRange.cloneRange();
      var text = '';
      if (oRange.startContainer.data) while (so >= 1) {
        tr.setStart(oRange.startContainer, --so);
        text = tr.toString();
        if (!isAlpha(text.charAt(0))) {
          tr.setStart(oRange.startContainer, so + 1);
          break;
        }
      }
      if (oRange.endContainer.data) while (eo < oRange.endContainer.data.length) {
        tr.setEnd(oRange.endContainer, ++eo);
        text = tr.toString();
        if (!isAlpha(text.charAt(text.length - 1))) {
          tr.setEnd(oRange.endContainer, eo - 1);
          break;
        }
      }
      var word = tr.toString();
      var oTarget = event.target;
      var $target = $(oTarget);
      //忽略一些标签
      if ($target.is('body')) {
        return false;
      }
      if (word.length >= 1) {
        var s = window.getSelection();
        s.removeAllRanges();
        s.addRange(tr);
        postSelectionChange();
        event.preventDefault();
        return false;
      }
      console.log(word);
    });
    // 告诉客户端修改了选中单词
    var postSelectionChange = function postSelectionChange() {
      //所有高亮取消
      console.log('postSelectionChange');
      console.log(window.getSelection());
      var selectionWord = window.getSelection().toString();
      console.log(selectionWord);
      console.log('that.lastValue');
      console.log(that.lastValue);
      console.log(that.lastValue != selectionWord);
      if (selectionWord && that.lastValue != selectionWord) {
        var rect = that.getSelectionRect();
        // document.querySelector(".super-headword-container").innerHTML = JSON.parse(rect).content + (index++);
        that.lastValue = window.getSelection().toString();
        that.selRange = window.getSelection().getRangeAt(0);
        console.log('rect:' + rect);
        /*<android>*/
        window.jsInterface && window.jsInterface.execute('cmd=selectionChange&rect=' + rect);
        /*</android>*/
      } else {
        that.lastValue = '';
      }
    };
  };
  /**
   * 获取选择对象
   */


  General.prototype.getSelectionRect = function getSelectionRect() {
    var json = {};
    var oSelection = window.getSelection();
    if (oSelection.toString()) {
      var selectRect = oSelection.getRangeAt(0).getBoundingClientRect();
      json.top = selectRect.top;
      json.right = selectRect.right;
      json.bottom = selectRect.bottom;
      json.left = selectRect.left;
      json.content = oSelection.toString();
      return JSON.stringify(json);
    }
  };
  // 删除选择？


  General.prototype.removeSelection = function removeSelection() {
    this.lastValue = '';
    window.getSelection().removeAllRanges();
  };
  // 继续选择


  General.prototype.resumeSelection = function resumeSelection() {
    window.getSelection().removeAllRanges();
    collins.isResume = true;
    window.getSelection().addRange(collins.selRange);
  };
  // 清除内容


  General.prototype.clearRenderContent = function clearRenderContent() {
    document.querySelector('body').innerHTML = '';
  };
  // 顶部距离


  General.prototype.setHeadGap = function setHeadGap(iGap) {
    document.querySelector('body').style.paddingTop = iGap + 'px';
  };
  // 底部距离


  General.prototype.setFootGap = function setFootGap(iGap) {
    document.querySelector('body').style.paddingBottom = iGap + 'px';
  };
  //设置主题


  General.prototype.setTheme = function setTheme(theme) {
    $('body').attr('class', '').addClass(theme);
  };

  return General;
}();