'use strict';

function setHeadGap(iGap) {
  document.querySelector('body').style.paddingTop = iGap + 'px';
}
$(function () {
  FastClick.attach(document.body);
  function fullscreen(elem) {
    var prefix = 'webkit';
    if (elem[prefix + 'EnterFullScreen']) {
      return prefix + 'EnterFullScreen';
    } else if (elem[prefix + 'RequestFullScreen']) {
      return prefix + 'RequestFullScreen';
    }
    return false;
  }
  var oVideo = document.querySelector('#video');
  var $btnPlay = $('#btnPlay');
  var $videoWrap = $('#videoWrap');
  $btnPlay.on('click', function () {
    if (oVideo.paused) {
      oVideo.play();
      /*<android>*/
      window.jsInterface.execute('cmd=play_collins_introduce');
      /*</android>*/
    } else {
      var fullscreenvideo = fullscreen(oVideo);
      oVideo[fullscreenvideo]();
    }
  });
  $(oVideo).on('play', function () {
    // $btnPlay.hide();
    // $videoCover.hide();
    $videoWrap.attr('class', 'video-wrap on');
    //每次只能播放一个视频对象
    var fullscreenvideo = fullscreen(oVideo);
    oVideo[fullscreenvideo]();
  });
  $(oVideo).on('ended', function () {
    $videoWrap.attr('class', 'video-wrap');
    // $videoWrap.addClass("on");
    // $btnPlay.show();
    // $videoCover.show();
  });
  $(oVideo).on('pause', function (e) {
    $videoWrap.attr('class', 'video-wrap paused');
    this.webkitExitFullScreen();
  });
  $('#btnBuy').on('click', function () {
    var href = $(this).attr('data-href');
    var payType = $(this).attr('data-pay-type');
    if (payType != 'iap') {
      href = href.replace('/iap', '');
    }
    window.open(href);
  });
});
window.action = {
  setTheme: function setTheme(theme) {
    $('body').attr('class', '').addClass(theme + '-theme');
  }
};